(function( $ ) {
	'use strict';
	$(function() {
		
		$('#upload_image').click(open_custom_media_window);

		function open_custom_media_window() {
			if (this.window === undefined) {
				this.window = wp.media({
					title: 'Insert Image',
					library: {type: 'image'},
					multiple: false,
					button: {text: 'Insert Image'}
				});

				var self = this;
				this.window.on('select', function() {
					var response = self.window.state().get('selection').first().toJSON();

					$('.wp_attachment_id').val(response.id);
					$('.image').attr('src', response.sizes.full.url);
					$('.image-path').attr('value', response.sizes.full.url);
					$('#header-image-preview').attr('src', response.sizes.full.url);
                    $('.image').show();
				});
			}

			this.window.open();
			return false;
		}
	});
	
	$(function() {
	
		$('#remove_image').click(remove_custom_media);

		function remove_custom_media() {
					
			$('.image').attr('src', '');
			$('.image-path').attr('value', '');
			$('#header-image-preview').attr('src', '');
								$('.image').hide();
		};
	});
	
	$(function() {
		
		var slider = $('#burger-size');
		var output = $('#current-size');
			//output.attr('width', slider.value);
			
			$(slider).change(update_slider_value);

		function update_slider_value() {
			output.attr('style', 'width: '+this.value+'px; font-size: '+this.value / 2+'px;');
		};
	});
	
	$(function() {

		$('#brand-color-picker').wpColorPicker({
			/**
			* @param {Event} event - standard jQuery event, produced by whichever
			* control was changed.
			* @param {Object} ui - standard jQuery UI object, with a color member
			* containing a Color.js object.
			*/
			change: function (event, ui) {
				var element = event.target;
				var color = ui.color.toString();
				var output = document.querySelector('#header_text_wrapper');

				output.setAttribute('style', 'color: '+color+';');
			},
		});
	} );
	
	$(function() {
		
		var rgb = {};

		$('#burger-bgd-color-picker').wpColorPicker({	
			
			/**
			* @param {Event} event - standard jQuery event, produced by whichever
			* control was changed.
			* @param {Object} ui - standard jQuery UI object, with a color member
			* containing a Color.js object.
			*/
			change: function (event, ui) {
				var element = event.target;
				var color = ui.color.toString();
			
				const setStyles		= document.getElementById('mmm-menu-button');
				const cssObj		= window.getComputedStyle(setStyles, null);
				let colorOg			= cssObj.getPropertyValue('background');
				
				roll_out(0, colorOg);
				
				setStyles.style.background	= 'linear-gradient(to right, '+rgb.rgbNew+', '+rgb.rgbOldTo+')';
				setStyles.style.filter		= 'drop-shadow(2px 4px 6px '+color+')';
								
				var output = document.querySelector('.mmm-slider-meter');
				output.setAttribute('style', 'border-color: transparent transparent '+color+' transparent;');
			},
		});

		$('#burger-gdt-color-picker').wpColorPicker({
			/**
			* @param {Event} event - standard jQuery event, produced by whichever
			* control was changed.
			* @param {Object} ui - standard jQuery UI object, with a color member
			* containing a Color.js object.
			*/
			change: function (event, ui) {
				var element = event.target;
				var color = ui.color.toString();
			
				const setStyles		= document.getElementById('mmm-menu-button');
				const cssObj		= window.getComputedStyle(setStyles, null);
				let colorOg			= cssObj.getPropertyValue('background');
				
				roll_out(1, colorOg);
				
				setStyles.style.background	= 'linear-gradient(to right, '+rgb.rgbOldFrom+', '+rgb.rgbNew+')';
			},
		});
		
		$('#burger-btn-color-picker').wpColorPicker({
			/**
			* @param {Event} event - standard jQuery event, produced by whichever
			* control was changed.
			* @param {Object} ui - standard jQuery UI object, with a color member
			* containing a Color.js object.
			*/
			change: function (event, ui) {
				var element = event.target;
				var color = ui.color.toString();
			
				const setStyles		= document.getElementById('mmm-menu-button');
				const cssObj		= window.getComputedStyle(setStyles, null);
				let colorOg			= cssObj.getPropertyValue('background');
				
				roll_out(2, colorOg);

				setStyles.style.color = rgb.rgbNew;
			},
		});
	
		$(function() {

			$('#menu-bgd-color-picker').wpColorPicker({
				/**
				* @param {Event} event - standard jQuery event, produced by whichever
				* control was changed.
				* @param {Object} ui - standard jQuery UI object, with a color member
				* containing a Color.js object.
				*/
				change: function (event, ui) {
					var element = event.target;
					var color = ui.color.toString();
					var output = document.querySelector('#menu-bgd-color-picker');

					output.setAttribute('style', 'color: '+color+';');
				},
			});
		} );
	
		$(function() {

			$('#menu-link-color-picker').wpColorPicker({
				/**
				* @param {Event} event - standard jQuery event, produced by whichever
				* control was changed.
				* @param {Object} ui - standard jQuery UI object, with a color member
				* containing a Color.js object.
				*/
				change: function (event, ui) {
					var element = event.target;
					var color = ui.color.toString();
					var output = document.querySelector('#menu-link-color-picker');

					output.setAttribute('style', 'color: '+color+';');
				},
			});
		} );	
	
		$(function() {

			$('#icon-bgd-color-picker').wpColorPicker({
				/**
				* @param {Event} event - standard jQuery event, produced by whichever
				* control was changed.
				* @param {Object} ui - standard jQuery UI object, with a color member
				* containing a Color.js object.
				*/
				change: function (event, ui) {
					var element = event.target;
					var color = ui.color.toString();
					var output = document.querySelector('#icon-bgd-color-picker');

					output.setAttribute('style', 'color: '+color+';');
				},
			});
		} );	
	
		$(function() {

			$('#icon-color-picker').wpColorPicker({
				/**
				* @param {Event} event - standard jQuery event, produced by whichever
				* control was changed.
				* @param {Object} ui - standard jQuery UI object, with a color member
				* containing a Color.js object.
				*/
				change: function (event, ui) {
					var element = event.target;
					var color = ui.color.toString();
					var output = document.querySelector('#icon-color-picker');

					output.setAttribute('style', 'color: '+color+';');
				},
			});
		} );

		function roll_out(pickerClass, colorOg) {
				
			const getStyles		= document.querySelectorAll('.color-alpha');
			const cssNew		= window.getComputedStyle(getStyles[pickerClass], null);
			let colorNew		= cssNew.getPropertyValue('background-color');
			
			let bgGrad = colorOg.replace('rgba(0, 0, 0, 0) linear-gradient(to right, ','');
			
			//Let's make usable values:
			
			const regExp = /[A-Za-z]+\([^)]*\)/g;
			const grad = [...bgGrad.match(regExp)];
			//Result after regExp:
				//grad[0] = rgb/a(###, ###, ###)/, ###)
				//grad[1] = rgb/a(###, ###, ###)/, ###)
			console.log(grad)

			rgb.rgbOldFrom	= grad[0];
			rgb.rgbOldTo	= grad[1];
			rgb.rgbNew		= colorNew;	
		}		
	});
	
	$(function() {
		
		var headerText = $('#header_text');
		var output = $('#chosen_font');
		
		$(headerText).change(update_text_content);
		
		function update_text_content() {
				output.text(headerText.val());
		};
	});
	
	$(function() {
		
		var selector = $('#header_font');
		var output = $('#chosen_font');
		
		$(selector).change(update_font_value);
		
		function update_font_value() {
				var listValue = $(selector).val();
				output.attr('style', 'font-family: \''+listValue+'\';');
		};
	});
	
	$(function () {
		
		var cta_char_one = $('#cta_char_one');
		var cta_char_two = $('#cta_char_two');
		var cta_char_three = $('#cta_char_three');
		
		$(cta_char_one).change(update_icon_value);
		$(cta_char_two).change(update_icon_value);
		$(cta_char_three).change(update_icon_value);
		
		function update_icon_value() {
			
			var cta_icon_one = document.getElementById('cta_icon_one');
			var cta_icon_two = document.getElementById('cta_icon_two');
			var cta_icon_three = document.getElementById('cta_icon_three');
			var cta_text_one = document.getElementById('cta_char_one');
			var cta_text_two = document.getElementById('cta_char_two');
			var cta_text_three = document.getElementById('cta_char_three');
			
			cta_icon_one.removeAttribute('class');
			cta_icon_one.setAttribute('class', 'cta-icon fas '+cta_char_one.val());
						
			cta_icon_two.removeAttribute('class');
			cta_icon_two.setAttribute('class', 'cta-icon fas '+cta_char_two.val());
						
			cta_icon_three.removeAttribute('class');
			cta_icon_three.setAttribute('class', 'cta-icon fas '+cta_char_three.val());
				
			cta_text_one.setAttribute('class', 'cta-char fas '+cta_char_one.val());
			cta_text_two.setAttribute('class', 'cta-char fas '+cta_char_two.val());
			cta_text_three.setAttribute('class', 'cta-char fas '+cta_char_three.val());
		};
	});

})( jQuery );
