(function( $ ) {
	'use strict';

	const buttonR = document.querySelector('#resize');
	const search = document.querySelector('.mmm-searchform');
	const cta = document.querySelector('.mmm-menu-cta');
	const button = document.querySelector('.mmm-menu-button');
	const menu = document.querySelector('#mmm-menu-body');
	const buttonX = document.querySelector('#close');
	const overlay = document.querySelector('.mmm-menu-overlay');
	const menuItems = document.querySelector('.mmm-sub-menu');

	const container = document.querySelector('#mmm-menu-items');
	const chevron = document.querySelector('.mmm-menu-switcher label');

	let subnav = document.querySelectorAll('.mmm-menu-switcher label');

	subnav.forEach(function (i) {
	 i.addEventListener('click', function() {
	  showMenu();
	 });
	});

	var x = document.body.querySelectorAll('.menu_item_has_children');


	let depth = 0;

	function showMMM() {
		button.setAttribute('hidden', '');
		menu.removeAttribute('hidden');
		overlay.removeAttribute('hidden');
	};

	function hideMMM() {
		menu.setAttribute('hidden', '');
		overlay.setAttribute('hidden', '');
		button.removeAttribute('hidden');
	};

	function showMenu() {
		var index = 0;
			for (index = 0; index < x.length; index++) {
				var navArrow = document.createElement('span');
				navArrow.className = 'mmm-menu-switcher';
				navArrow.innerHTML = '<b>[toggle]</b>';
				x[index].parentNode.insertBefore(navArrow, x[index].nextSibling);
		}

		var elements = document.querySelectorAll('.mmm-menu-switcher');

		for(var i in elements) {
			if(elements.hasOwnProperty(i)) {
				elements[i].onclick = function() {
					if (this.parentElement.querySelector('.mmm-sub-menu').hasAttribute('hidden')) {
						this.parentElement.querySelector('.mmm-sub-menu').removeAttribute('hidden');
						this.parentElement.querySelector('#sub-menu-label').setAttribute('class','fas fa-level-up-alt');
					} else {
						this.parentElement.querySelector('.mmm-sub-menu').setAttribute('hidden', '');
						this.parentElement.querySelector('#sub-menu-label').setAttribute('class','fas fa-level-down-alt');
					}
				}
			}
		}
	};

	function resizeMenu() {
		
		//var soundsUrl = $('script[src*=munky-mm-public]').attr('src');		// path of this file
			//soundsUrl = soundsUrl.replace(/\?.*/,'');						// remove ?ver= from end of path if it exists
			//soundsUrl = soundsUrl.replace('munky-mm-public.js', '../snd/');	// replace the filename of this file with the relative directory for sounds
		//var grow = new Audio( soundsUrl+'grow.mp3' );
		//var shrink = new Audio( soundsUrl+'shrink.mp3' );
		
		if (search.hasAttribute('style')) {
			//grow.play();
			buttonR.setAttribute('class','fas fa-sign-out-alt fa-border fa-rotate-90');
			search.removeAttribute('style');
			cta.setAttribute('style','display: flex;');
		} else {
			//shrink.play();
			buttonR.setAttribute('class','fas fa-sign-in-alt fa-border fa-rotate-270');
			search.setAttribute('style','display: none;');
			cta.setAttribute('style','display: none;');
		}
	};

	button.addEventListener('click', showMMM);
	buttonX.addEventListener('click', hideMMM);
	overlay.addEventListener('click', hideMMM);
	buttonR.addEventListener('click', resizeMenu);
	//subnav.addEventListener('click', showMenu);

})( jQuery );
