<?php

/**
 * Provide a public-facing view for the plugin
 *
 * This file is used to markup the public-facing aspects of the plugin.
 *
 * @link    https://heymunky.co.uk
 * @since   1.0.0
 *
 * @package  Munky_Mm
 * @subpackage Munky_Mm/public/partials
 */
?>

<?php

	$brandOpts	= get_option( 'munky-menu-branding_options' );
	$burgerOpts	= get_option( 'munky-menu-burger_options' );
	$menuOpts	= get_option( 'munky-menu-menu_options' );
	
	//Turn each setting of Branding Options into a variable	
	foreach ( $brandOpts as $brandOpt => $setting ) {
		$$brandOpt = $setting;
	}	
	/* Variables: -
		$brand_color;
		$header_text;
		$header_font;
		$header_logo;
	*/
	
	//Turn each setting of Burger Options into a variable		
	foreach ( $burgerOpts as $burgerOpt => $setting ) {
		$$burgerOpt = $setting;
	}	
	/* Variables: -
		$burger_background_color;
		$burger_gradient_color;
		$burger_button_color;
		$burger_size;
	*/

	//Turn each setting of Main Menu Options into a variable		
	foreach ( $menuOpts as $menuOpt => $setting ) {
		$$menuOpt = $setting;
	}	
	/* Variables: -
		$menu_background_color;
		$menu_link_color;
		$icon_background_color;
		$icon_color;
		$cta_icon_one;
		$cta_icon_two;
		$cta_icon_three;
		$cta_title_one;
		$cta_title_two;
		$cta_title_three;
		$cta_url_one;
		$cta_url_two;
		$cta_url_three;
	*/
	
	//define constants needed for main navwalker
	//define( menu_link_color, $menu_link_color );
	//define( icon_color, $icon_color );
	
	// if cta_url starts with / then use home_url
	if(substr($cta_url_one, 0, 1) == '/'){$cta_url_one = home_url( $cta_url_one );}
	if(substr($cta_url_two, 0, 1) == '/'){$cta_url_two = home_url( $cta_url_two );}
	if(substr($cta_url_three, 0, 1) == '/'){$cta_url_three = home_url( $cta_url_three );}
	
	$burger_font = $burger_size/2;
?>

<span id="mmm-burger-menu" class="mmm-menu">
	<button class="mmm-menu-button" style="width: <?php echo $burger_size; ?>px; font-size: <?php echo $burger_font; ?>px; background: linear-gradient(to right, <?php echo $burger_background_color; ?>, <?php echo $burger_gradient_color; ?>); color: <?php echo $burger_button_color; ?>; box-shadow: 0 2px 40px -10px <?php echo $burger_background_color; ?>;">
	</button>
</span>
		
<section id="mmm-menu-body" style="background-color: <?php echo $menu_background_color; ?>;" hidden="hidden">
<div class="mmm-menu-banner" style="background-color: <?php echo $menu_background_color; ?>;"><span class="mmm-banner-text" style="color: <?php echo $brand_color; ?>; font-family: <?php echo $header_font; ?>;"><img class="mmm-banner-image" src="<?php echo $header_logo; ?>"><?php echo $header_text; ?></span></div>
	<div class="mmm-menu-header" style="background-color: <?php echo $menu_background_color; ?>;">
		<button id="resize" title="Resize" class="fas fa-sign-out-alt fa-border fa-rotate-90" style="border-color: <?php echo $menu_background_color; ?>!Important; background-color: <?php echo $icon_background_color; ?>; color: <?php echo $icon_color; ?>;"></button>
		<button id="close" title="Close" class="fas fa-power-off fa-border" style="border-color: <?php echo $menu_background_color; ?>!Important; background-color: <?php echo $icon_background_color; ?>; color: <?php echo $icon_color; ?>;"></button>
	</div>
	<div class="mmm-searchform">
		<form role="search" method="get" id="mmm-searchform" action="<?php echo esc_url( home_url( '/' ) ); ?>" >
		<div class="custom-form"><label class="screen-reader-text" for="s">' . __( 'Search:' ) . '</label>
			<input type="text" value="" name="s" id="s" />
			<input type="submit" id="mmm-search" class="fas fa-search" style="background: <?php echo $icon_background_color; ?>; color: <?php echo $icon_color; ?>;" value="&#xf002;" />
		</div>
		</form>
	</div>
	
	<div class="mmm-menu-links" style="color: <?php echo $menu_link_color; ?>;">
	
	<?php munky_mobile_menu(); ?>	
	
	</div>
	
	<div class="mmm-menu-cta">
	
	<?php 
	
		//if either icon or title fields are empty then don't display the button
	
		if ( !empty($cta_icon_one) ) {
			echo '<span style="background: ' . $icon_background_color . '; color: ' . $brand_color . ';"><a class="cta-color" href="' . esc_url($cta_url_one) . '"><li class="fas ' . $cta_icon_one . '"></li><p>' . $cta_title_one . '</p></a></span>';
		} else {
			echo '<span style="display: none;"></span>';
		}
	
		if ( !empty($cta_icon_two)  ) {			
			echo '<span style="background: ' . $icon_background_color . '; color: ' . $brand_color . ';"><a class="cta-color" href="' . esc_url($cta_url_two) . '"><li class="fas ' . $cta_icon_two . '"></li><p>' . $cta_title_two . '</p></a></span>';
		} else {
			echo '<span style="display: none;"></span>';
		}
	
		if ( !empty($cta_icon_three) ) {
			echo '<span style="background: ' . $icon_background_color . '; color: ' . $brand_color . ';"><a class="cta-color" href="' . esc_url($cta_url_three) . '"><li class="fas ' . $cta_icon_three . '"></li><p>' . $cta_title_three . '</p></a></span>';
		} else {
			echo '<span style="display: none;"></span>';
		}
	?>
	
		</div><!--mmm-menu-contact-->
</section>
<div class="mmm-menu-overlay" hidden="hidden"></div>

<?php

//if ( ! function_exists( 'munky_mobile_menu' ) ) :

	function munky_mobile_menu() {

		// display the WordPress Custom Menu if available
		wp_nav_menu( array(
			'menu'       		=> 'main',
			'theme_location'	=> 'primary',
			'container'			=> '',
			'container_class'	=> '',
			'menu_id'			=> 'mmm-menu-items',
			'menu_class'		=> '',
			'echo'				=> True,
			'fallback_cb'		=> 'Munky_Navwalker::fallback',
			'walker'			=> new Munky_Navwalker(),
		));
	}
//endif;

class Munky_Navwalker extends Walker_Nav_Menu {
	private $curItem;

		/**
		 * @see Walker::start_lvl()
		 * @since 3.0.0
		 *
		 * @param string $output Passed by reference. Used to append additional content.
		 * @param int $depth Depth of page. Used for padding.
		 */
	public function start_lvl( &$output, $depth = 0, $args = array() ) {		
		//var_dump($this->curItem );
		$output .= /*$indent . */'<ul id="sub-menu-' . $this->curItem . '-level-' . $depth . '" class="mmm-sub-menu" hidden="hidden" role="menu">';
	}

		/**
		 * @see Walker::start_el()
		 * @since 3.0.0
		 *
		 * @param string $output Passed by reference. Used to append additional content.
		 * @param object $item Menu item data object.
		 * @param int $depth Depth of menu item. Used for padding.
		 * @param int $current_page Menu item ID.
		 * @param object $args
		 */
	public function start_el( &$output, $item, $depth = 0, $args = array(), $id = 0 ) {
		$this->curItem = $item->object_id;

		/**
		 * Dividers, Headers or Disabled
		 * =============================
		 * Determine whether the item is a Divider, Header, Disabled or regular
		 * menu item. To prevent errors we use the strcasecmp() function to so a
		 * comparison that is not case sensitive. The strcasecmp() function returns
		 * a 0 if the strings are equal.
		 */
		if ( 0 == strcasecmp( $item->attr_title, 'divider' ) && 1 === $depth ) {
			$output .= /*$indent . */'<li role="presentation" class="divider">';
		} elseif ( 0 == strcasecmp( $item->title, 'divider' ) && 1 === $depth ) {
			$output .= /*$indent . */'<li role="presentation" class="divider">';
		} elseif ( 0 == strcasecmp( $item->attr_title, '' ) && 1 === $depth ) {
			$output .= /*$indent . */'<li role="presentation" class="mmm-sub-menu-item"><a href="' . $item->url . '" style="color: ' . $menu_link_color . ';">' . esc_attr( $item->title );
			$output .= ( $args->has_children ) ? ' </a><span id="L' . $item->ID . '" class="mmm-menu-switcher"><label id="sub-menu-label" class="fas fa-level-down-alt" style="color: ' . $icon_color . ';"></label></span>' : '</a>';
		} elseif ( 0 == strcasecmp( $item->attr_title, 'disabled' ) ) {
			$output .= /*$indent . */'<li role="presentation" class="disabled"><a href="#">' . esc_attr( $item->title ) . '</a>';
		} else {
			$class_names = '';
			$value = '';
			$classes = empty( $item->classes ) ? array() : (array) $item->classes;
			$classes[] = 'mmm-menu-item';

			$class_names = join( ' ', apply_filters( 'nav_menu_css_class', array_filter( $classes ), $item, $args ) );

			//if ( $args->has_children )
			 //    $class_names .= ' menu-item-has-children';

			if ( in_array( 'current-menu-item', $classes ) ) {
					$class_names .= ' active';
			}

			$class_names = $class_names ? ' class="' . esc_attr( $class_names ) . '"' : '';

			$id = apply_filters( 'nav_menu_item_id', 'menu-item-' . $item->ID, $item, $args );
			$id = $id ? ' id="' . esc_attr( $id ) . '"' : '';

			$output .= /*$indent . */'<li' . $id . $value . $class_names . '>';

			$atts = array();
			$atts['title'] = ! empty( $item->title )	? $item->title		: '';
			$atts['target'] = ! empty( $item->target )	? $item->target		: '';
			$atts['rel']  = ! empty( $item->xfn )		? $item->xfn		: '';

			// If item has_children add atts to a.
			if ( 0 === $args->has_children && $depth ) {
				$atts['href']         = ! empty( $item->url ) ? $item->url : '';
				// $atts['data-toggle']    = 'dropdown';
				$atts['class']         = '';
			} else {
				$atts['href'] = ! empty( $item->url ) ? $item->url : '';
			}

			$atts = apply_filters( 'nav_menu_link_attributes', $atts, $item, $args );

			$attributes = '';
			foreach ( $atts as $attr => $value ) {
				if ( ! empty( $value ) ) {
					$value = ( 'href' === $attr ) ? esc_url( $value ) : esc_attr( $value );
					$attributes .= ' ' . $attr . '="' . $value . '"';
				}
			}

			$item_output = $args->before;

			/*
			 * Glyphicons
			 * ===========
			 * Since the the menu item is NOT a Divider or Header we check the see
			 * if there is a value in the attr_title property. If the attr_title
			 * property is NOT null we apply it as the class name for the glyphicon.
			 */
			if ( ! empty( $item->attr_title ) ) {
					$item_output .= '<a' . $attributes . '><span class="glyphicon ' . esc_attr( $item->attr_title ) . '"></span>&nbsp;';
			} else {         $item_output .= '<a' . $attributes . ' style="color: ' . $menu_link_color . ';">';
			}

			$item_output .= $args->link_before . apply_filters( 'the_title', $item->title, $item->ID ) . $args->link_after;
			$item_output .= ( $args->has_children ) ? ' </a><span id="L' . $item->ID . '" class="mmm-menu-switcher"><label id="sub-menu-label" class="fas fa-level-down-alt" style="color: ' . $icon_color . ';"></label></span>' : '</a>';
			$item_output .= $args->after;

			$output .= apply_filters( 'walker_nav_menu_start_el', $item_output, $item, $depth, $args );
		}// End if().
	}

		/**
		 * Traverse elements to create list from elements.
		 *
		 * Display one element if the element doesn't have any children otherwise,
		 * display the element and its children. Will only traverse up to the max
		 * depth and no ignore elements under that depth.
		 *
		 * This method shouldn't be called directly, use the walk() method instead.
		 *
		 * @see Walker::start_el()
		 * @since 2.5.0
		 *
		 * @param object $element Data object
		 * @param array $children_elements List of elements to continue traversing.
		 * @param int $max_depth Max depth to traverse.
		 * @param int $depth Depth of current element.
		 * @param array $args
		 * @param string $output Passed by reference. Used to append additional content.
		 * @return null Null on failure with no changes to parameters.
		 */
	public function display_element( $element, &$children_elements, $max_depth, $depth, $args, &$output ) {
		if ( ! $element ) {
			return;
		}

		$id_field = $this->db_fields['id'];

		// Display this element.
		if ( is_object( $args[0] ) ) {
			$args[0]->has_children = ! empty( $children_elements[ $element->$id_field ] );
		}

		parent::display_element( $element, $children_elements, $max_depth, $depth, $args, $output );
	}

		/**
		 * Menu Fallback
		 * =============
		 * If this function is assigned to the wp_nav_menu's fallback_cb variable
		 * and a manu has not been assigned to the theme location in the WordPress
		 * menu manager the function with display nothing to a non-logged in user,
		 * and will add a link to the WordPress menu manager if logged in as an admin.
		 *
		 * @param array $args passed from the wp_nav_menu function.
		 *
		 */
	public static function fallback( $args ) {
		$fb_output = null;

		if ( $args['container'] ) {
			$fb_output = '<' . $args['container'];

			if ( $args['container_id'] ) {
					$fb_output .= ' id="' . $args['container_id'] . '"';
			}

			if ( $args['container_class'] ) {
					$fb_output .= ' class="' . $args['container_class'] . '"';
			}

			$fb_output .= '>';
		}

		$fb_output .= '<ul';

		if ( $args['menu_id'] ) {
				$fb_output .= ' id="' . $args['menu_id'] . '"';
		}

		if ( $args['menu_class'] ) {
				$fb_output .= ' class="' . $args['menu_class'] . '"';
		}

		$fb_output .= '>';
		$fb_output .= wp_list_pages( array(
			'depth' => 1, //number of tiers, 0 for unlimited
			'exclude' => '', //comma seperated IDs of pages you want to exclude
			'title_li' => '', //must override it to empty string so that it does not break our nav
			'sort_column' => 'post_title', //see documentation for other possibilites
			'sort_order' => 'ASC', //ASCending or DESCending
			'echo' => false,
		));
		$fb_output .= '</ul>';

		if ( $args['container'] ) {
				$fb_output .= '</' . $args['container'] . '>';
		}

		echo $fb_output;
	}
}

?>
